# Written by Eleandor (www.infinity-universe.com)

module CountTriangles

require 'sketchup.rb'

def CountTriangles.count_tris_helper(entity_list)
	triangles = 0
	for e in entity_list
		if e.class == Sketchup::Face
			triangles += e.edges.length-2
		end
		if (e.class == Sketchup::Group)
			triangles += count_tris_helper(e.entities)
		end
		if e.class == Sketchup::ComponentInstance
			triangles += count_tris_helper(e.definition.entities)
		end
	end
	return triangles
end # count_tris_helper

def CountTriangles.count_tris_model()
	UI.messagebox("Triangles: " + CountTriangles.count_tris_helper(Sketchup.active_model.entities).to_s)
end

def CountTriangles.count_tris_selected()
	UI.messagebox("Triangles: " + CountTriangles.count_tris_helper(Sketchup.active_model.selection).to_s)
end


UI.menu("Plugins").add_item("Count triangles in model") { CountTriangles.count_tris_model }
UI.menu("Plugins").add_item("Count triangles in current selection") { CountTriangles.count_tris_selected }

end # module CountTriangles